# mkdir -p ~/todo/do ~/todo/done
# add this code to your .bashrc
# type 'todo taskname' at the prompt to add a task
# type 'fin taskname' at the prompt to remove a task
# https://sambrin.medium.com/fin-command-line-todo-list-made-with-30a2346de068
#STANDARD="\e[0m"
   TODO_LIST_LABEL="\n----------Todo List-----------\n"
   TODO_LIST_END="\n------------------------------\n"
   COMP_LIST_LABEL="\n----------Done List-----------\n"
   COMP_LIST_END="\n------------------------------\n"
TASKS_DIR=~/todo/do/
COMPLETED_DIR=~/todo/done/
function todo {
 if [ -z "$1" ]
 then
   printf "${TODO_LIST_LABEL}"
   find ${TASKS_DIR} -not -path '*/\.*' -type f -execdir echo '{}' ';' | nl -s ' ' -b n
   printf "${TODO_LIST_END}"
 else
   touch ${TASKS_DIR}"${*}"
   todo
 fi
}
_fin () {
   IFS=$'\n' tmp=( $(compgen -W "$(ls "${TASKS_DIR}")" -- "${COMP_WORDS[$COMP_CWORD]}" ))
   COMPREPLY=( "${tmp[@]// /\ }" )
   IFS=$' '
}
function fin {
 if ! [[ -z "$1" ]] && [ -e ${TASKS_DIR}"${*}" ]
 then
   mv ${TASKS_DIR}"${*}" ${COMPLETED_DIR}
   todo
   printf " ${*} removed from list \n\n"
 else
#  echo -e "\nusage: fin [existing task to complete]\n"
   printf "${COMP_LIST_LABEL}"
   find ${COMPLETED_DIR} -not -path '*/\.*' -type f -execdir echo '{}' ';' | nl -s ' ' -b n
   printf "${COMP_LIST_END}" 
 fi
}
complete -o default -F _fin fin
